#!/bin/bash

# Input: XML Melt file (XML Consumer)
# Output: Kdenlive Project

# Input check
[ ! -f "$1" ] && echo "File does not exist." && exit 1

input="$1"
output="${input%.*}-converted.kdenlive"

# ==============================
# === Kdenlive XML structure ===
# ==============================

# Kdenlive modifies the default MLT file, generated by MELT. These are the XML structures Kdenlive uses to recognize valid .kdenlive files and properly open them within the editor.
# The {NUMBERS} are replaced with data from the MLT file generated by the MELT command.

# Some references:
# https://invent.kde.org/multimedia/kdenlive/-/blob/master/dev-docs/mlt-intro.md
# https://www.mltframework.org/docs/melt/
# https://www.mltframework.org/docs/mltxml/

# https://serverfault.com/a/72511
read -r -d '' kdenlive_xml <<"EOF"
  <playlist id="main_bin">
    <property name="xml_retain">1</property>
{0}
  </playlist>
  <playlist id="playlist1"/>
  <playlist id="playlist2">
{1}
  </playlist>
  <playlist id="playlist3"/>
  <tractor id="tractor0" in="0" out="12183">
    <property name="kdenlive:audio_track">1</property>
    <property name="kdenlive:trackheight">67</property>
    <property name="kdenlive:timeline_active">1</property>
    <track hide="video" producer="playlist0"/>
    <track hide="video" producer="playlist1"/>
  </tractor>
  <tractor id="tractor1" in="00:00:00.000" out="{2}">
    <property name="kdenlive:trackheight">67</property>
    <property name="kdenlive:timeline_active"/>
    <property name="kdenlive:thumbs_format"/>
    <property name="kdenlive:audio_rec"/>
    <track producer="playlist2"/>
    <track producer="playlist3"/>
  </tractor>
  <tractor id="tractor2" in="00:00:00.000" out="{3}">
    <track producer="tractor0"/>
    <track producer="tractor1"/>
  </tractor>
EOF

# =============================================
# === Convert from Melt XML to Kdenlive XML ===
# =============================================

# Insert producer="main_bin" into <mlt> params after LC_NUMERIC="..."
sed 's/LC_NUMERIC="[^"]\+"/& producer="main_bin"/' -i "$input"

# Remove tractor0 and its tracks
sed -e '/tractor/d' -e '/track/d' -i "$input"

# Get <entry> tags within playlist0
playlist_entries="$(grep "<entry" "$input")"

# Get last <entry>
last_entry="$(echo "$playlist_entries" | tail -n 1)"

# Get value from out="value" in the last entry
video_length=$(echo "$last_entry" | grep -o 'out=".*"' | tr -cd '[:digit:]')

# Make a copy of the project file (awk couldn't save the text to the same file)
cp "$input" "$output"

# Insert kdenlive_xml content on the line before </mlt>, then remove empty lines https://stackoverflow.com/a/2512379
awk -vf2="$kdenlive_xml" '/\/mlt/{print f2;print;next}1' "$input" > "$output"

sed "s|{0}|$last_entry|" -i "${output}"
sed "s|{1}|$playlist_entries|" -i "${output}"
sed "s/{2}/$video_length/" -i "${output}"
sed "s/{3}/$video_length/" -i "${output}"
